
# Scrabble Score

Given a word, compute the scrabble score for that word.  

Whilst this project does what it says on the tin, you've noticed a way in which it can be improved. It'd be better if the programme allowed you to enter more words before exiting, and it'd be great if it kept track of the total score.  

This project will introduce a workflow for logging these issues, and best practices for getting potential fixes merged into the project.

---

## Issue Tracking

Once you have identified an issue that you'd like to see resolved, you should capture it in the project's Issue Tracker. GitLab groups an issue tracker in with the other project's resources. It can be found listed on the side bar of your fork of the project page - ie `https://gitlab.com/<your-namespace>/project2`.  
GitLab's issue tracker is intuitive to use and there's little to said here that'd help other than to say dive right in and create an issue.

---

## Branching

### Overview
Branches are fundamental to Git work flows. They are lightweight and are trivial to create and destroy. They allow code to be changed in isolation for the development of features and the fixing of bugs / issues.  
A repo will have a default branch, usually called `master`, but can be named anything at all as there is nothing special about this branch other than its purpose. The `master` branch is where to look for the most stable copy of the code and the point at which to begin if you'd like to make any changes.  
It is considered bad practice to push any changes directly to the `master` branch (GitLab will prevent this by protecting the `master` branch). If you wish to make changes to a repo then correct workflow is to create a new branch off `master`, make changes there, push that branch, create a merge request and then merge that branch back into the `master` branch.  
This is a brief overview of the process and we'll use this project as an example of how to make changes in a repo.

### Creating a branch
After you've cloned the repo, you will be on the default (`master`) branch. You can confirm this by typing `git status` and you'll see something like:

    On branch master  
    Your branch is up to date with 'origin/master'.
    
    nothing to commit, working tree clean

Before you make any changes to any of the files, you should create a new branch so that you can work safely. In Git, you use `git checkout <branch>` to swap between branches. If we're creating a new branch, you need to tell Git that it's new and this is done with the `-b` argument. A branch can be called anything you like but a good convention is to use `<username>/feature`.

    15:47 $ git checkout -b gthreepwood/loop_input
    Switched to a new branch 'gthreepwood/loop_input'

Any changes you make to the code now can be saved (committed) to your branch. It is good practice to commit often, as it can allow you rollback changes if you opt to change your approach to a problem. If you push these commits to a remote then it also means your work is backed-up. We'll discussing pushing later.

Once you are happy with your changes you should use `git add` and `git commit` to apply them to your branch. Refer to [using Git](https://gitlab.com/ct-starter-guide/how-to-git-going-in-foss/-/blob/master/tutorials/using_git.md) for more information on how to do that.

## Running the tests
In order to test our [scrabble scorer](scrabble_score.py) works as expected, tests have been
written that use the [pytest framework](https://docs.pytest.org/en/latest/).

To run the tests, run the appropriate command below:

    pytest scrabble_score_test.py

If this does not work, you probably don't have pytest installed as it's own package.
So, alternatively, you can try to Python to run the pytest module:

    python3 -m pytest scrabble_score_test.py

If neither of these commands work, you'll have to install Pytest on your system.
If you're using debian, try:

    sudo apt-get install python3-pytest

To verify this has installed, try `pytest --help`, and you should see the Pytest
help message.

Consult your supervisor if you need help or once you have all the tests passing.


### Common `pytest` options

- `-v` : enable verbose output
- `-x` : stop running tests on first failure
- `--ff` : run failures from previous test before running other test cases

For other options, see `python -m pytest -h`

### Commit Messages

When you make changes to a project, it is important that you articulate why you are making these changes. This is done in the commit message.  [This](https://chris.beams.io/posts/git-commit/) is good overview of best practice but can tl;dr'd as the following:

#### The seven rules of a great Git commit message

1. Separate subject from body with a blank line  
2. Limit the subject line to 50 characters  
3. Capitalize the subject line  
4. Do not end the subject line with a period  
5. Use the imperative mood in the subject line  
6. Wrap the body at 72 characters  
7. Use the body to explain what and why vs. how  

### Pushing your branch

Once you are you ready to submit your changes you should push your branch to the remote Git repo (usually named `origin`). This is done with `git push origin <branch>`

    11:51 $ git push origin gthreepwood/loop_input 
    Enumerating objects: 3, done.
    Counting objects: 100% (3/3), done.
    Delta compression using up to 8 threads
    Compressing objects: 100% (2/2), done.
    Writing objects: 100% (2/2), 293 bytes | 293.00 KiB/s, done.
    Total 2 (delta 1), reused 0 (delta 0)
    remote: 
    remote: To create a merge request for gthreepwood/loop_input, visit:
    remote:   https://gitlab.com/ct-interns/project2/merge_requests/new?merge_request%5Bsource_branch%5D=gthreepwood%2Floop_input
    remote: 
    To gitlab.com:ct-interns/project2.git
    * [new branch]      gthreepwood/loop_input -> gthreepwood/loop_input

You'll notice that GitLab will return a URL for you to visit to set up a Merge Request for this change. The MR is the formal way of asking the project maintainers to Review your code, and consider merging it into the `master` branch.

## Create Merge Request

To create the merge request, visit the URL that was returned when you pushed your branch or return to your project fork within GitLab and select `Merge Requests` -> `New Merge Request` from the side bar; which should take you to `https://gitlab.com/<your-namespace>/project2/merge_requests`.  
Follow the instructions laid out there, and be sure to link to the Issue that you raised at the beginning of the process. This is done simply by `#<issue-number>` and GitLab will do the rest.

## Code Review

Code review is an important part of the development process.
Projects often require independent review of each Merge Request from 2 engineers before anything can be considered for merge.

This has many benefits:

- It allows fresh eyes onto a Merge Request to validate the code / approach and style.

- It improves the quality of the code as anything ambiguous can be questioned, discussed and clarified (either in code or in the supporting comments).

- It allows others to ensure that you have not skipped any essential parts of the software development process such as design documentation, unit tests, etc.

- Other engineers can become familiar with other parts of the project that they are not actively developing on.

- It can offer reassurance that the approach you've taken is sane and that your solution is good. It is common to begin coding through a problem, unsure if it is the best path - and then having it validated in review boosts confidence.

- Helps ensure that the engineer has understood the API of any other module in the system that they are calling or retrieving information from.

To review code properly takes time, and that means taking time out of
your current task to review other peoples code. This can be tough
sometimes when you're focused in on trying to solve a particular
problem, within a tight time frame.  
However, there will always be time allocated for review on projects and consider once you've completed your own MR it cannot be merged until another two engineers have set some of their own time aside to review your work.

In summary, make noise about your reviews, bug your fellow
engineers to review your work. Review their work, learn about the project and be better programmers

---
---